﻿Friend Class Game : Inherits NotifyPropertyChangedBaseClass

	Event DiceThrow As EventHandler(Of DiceThrowingEventArgs)

	Private _PlayerVictoryCount As Integer
	Property PlayerVictoryCount As Integer
		Get
			Return _PlayerVictoryCount
		End Get
		Private Set
			If Not ValueChanges(_PlayerVictoryCount, Value) Then Return

			_PlayerVictoryCount = Value
			OnPropertyChanged()
		End Set
	End Property

	Private _ComputerVictoryCount As Integer
	Property ComputerVictoryCount As Integer
		Get
			Return _ComputerVictoryCount
		End Get
		Private Set
			If Not ValueChanges(_ComputerVictoryCount, Value) Then Return

			_ComputerVictoryCount = Value
			OnPropertyChanged()
		End Set
	End Property

	Private _DrawCount As Integer
	Property DrawCount As Integer
		Get
			Return _DrawCount
		End Get
		Private Set
			If Not ValueChanges(_DrawCount, Value) Then Return

			_DrawCount = Value
			OnPropertyChanged()
		End Set
	End Property

	Private ReadOnly Random As New Random

	Sub ThrowDice()
		Dim PlayerResult = Random.Next(6) + 1
		Dim ComputerResult = Random.Next(6) + 1
		Dim Result As ThrowResult
		If PlayerResult < ComputerResult Then
			ComputerVictoryCount += 1
			Result = ThrowResult.ComputerWon
		ElseIf PlayerResult = ComputerResult Then
			DrawCount += 1
			Result = ThrowResult.Draw
		Else
			PlayerVictoryCount += 1
			Result = ThrowResult.PlayerWon
		End If

		RaiseEvent DiceThrow(Me, New DiceThrowingEventArgs With {.Result = Result, .PlayerResult = PlayerResult, .ComputerResult = ComputerResult})
	End Sub

	Sub LoadDataFrom(GameStatistics As (PlayerVictoryCount As Integer, ComputerVictoryCount As Integer, DrawCount As Integer))
		PlayerVictoryCount = GameStatistics.PlayerVictoryCount
		ComputerVictoryCount = GameStatistics.ComputerVictoryCount
		DrawCount = GameStatistics.DrawCount
	End Sub

End Class