﻿Friend Class GameFileContentManager

	Private ReadOnly FileName As String = Nothing

	Sub New(FileName As String)
		Me.FileName = FileName
	End Sub

	Function GetGameStatisticsFromFile() As (PlayerVictoryCount As Integer, ComputerVictoryCount As Integer, DrawCount As Integer)
		If Not IO.File.Exists(FileName) Then Return (0, 0, 0)

		Dim FileLines = IO.File.ReadAllLines(FileName)
		If FileLines.Length < 3 Then Return (0, 0, 0)

		Dim PlayerVictoryCount = Integer.Parse(FileLines(0))
		Dim ComputerVictoryCount = Integer.Parse(FileLines(1))
		Dim DrawCount = Integer.Parse(FileLines(2))
		Return (PlayerVictoryCount, ComputerVictoryCount, DrawCount)
	End Function

	Sub WriteGameStatisticsToFile(GameStatistics As (PlayerVictoryCount As Integer, ComputerVictoryCount As Integer, DrawCount As Integer))
		IO.File.WriteAllLines(FileName, {GameStatistics.PlayerVictoryCount.ToString, GameStatistics.ComputerVictoryCount.ToString, GameStatistics.DrawCount.ToString})
	End Sub

End Class