﻿Class RelayCommand : Implements System.Windows.Input.ICommand

	Event CanExecuteChanged As EventHandler Implements System.Windows.Input.ICommand.CanExecuteChanged

	Private ReadOnly CommandAction As Action
	Private ReadOnly CanExecuteCommandAction As Func(Of Boolean)

	Sub New(CommandAction As Action)
		ArgumentNullException.ThrowIfNull(CommandAction, NameOf(CommandAction))

		Me.CommandAction = CommandAction
	End Sub

	Sub New(CommandAction As Action, CanExecuteCommandAction As Func(Of Boolean))
		ArgumentNullException.ThrowIfNull(CommandAction, NameOf(CommandAction))

		Me.CommandAction = CommandAction
		Me.CanExecuteCommandAction = CanExecuteCommandAction
	End Sub

	Function CanExecute(Parameter As Object) As Boolean Implements System.Windows.Input.ICommand.CanExecute
		Return CanExecuteCommandAction Is Nothing OrElse CanExecuteCommandAction.Invoke
	End Function

	Sub Execute(Parameter As Object) Implements System.Windows.Input.ICommand.Execute
		CommandAction()
	End Sub

	Sub NotifyCanExecuteChanged()
		RaiseEvent CanExecuteChanged(Me, EventArgs.Empty)
	End Sub

End Class
